addpath ../sparse
close all
clear all
A = fd3d(20, 20, 5, 0.1, -0.2, 0.1, 0.4);
n = size(A,1);
rhs = A*[1:n]';
x0 = randn(n,1);
tol = 1.e-10; m = 200;
[res1,sol] = gmres0(A,rhs,x0,100,tol,m) ;
[res2,sol] = BiCG (A, rhs, x0, m, tol) ;
[res3,sol] = cgs (A, rhs, x0, m, tol);
[res4,sol] = bcgstab(A, rhs, x0, m, tol) ;
%%--------------------
its = [1:length(res1)] ;
semilogy(its,res1,'k','linewidth',2);
hold 
its = [1:length(res2)] ; its = its*2-1;
semilogy(its,res2,'r-','linewidth',2);
its = [1:length(res3)] ; its = its*2-1;
semilogy(its, res3,'b-','linewidth',2);
its = [1:length(res4)] ; its = its*2-1;
semilogy(its,res4,'r--','linewidth',2);
xlabel('Matrix-vector products','fontsize',16) ;
ylabel('Res. norm','fontsize',16) ;

h1 = legend('gmres','bicg','cgs', 'bcgstab')
set(h1,'fontsize',18) 
