 function A = convdiff(n,m,alpha)  
%
%  a = convdiff (n,m,alpha) generates a 5-point 
%  Diffusion/conv. matrix - dimension is n*m  
%
OD = spdiags(ones(n-1,1), -1,n,n);
D = 4*speye(n) - (1-alpha)*OD - (1+alpha)*OD';
I = speye(n);
A = D;
B = -I;
for j = 1:m-1
   A = [A, B; B',D];
   B = [sparse(n,n); B];
end

