function [r] = thomas (b, d, a, r) 
%%  function [r] = thomas (a, d, b, r) 
%%  thomas algorithm for tridag. systems
%%  note: a, b, d are all of length n - 
%%  with a(n) = 0 and b(1) = 0.
%% 
n = length(d);
for k=1:n-1 
  a(k) = a(k) / d(k);
  r(k) = r(k) / d(k);
  d(k+1) = d(k+1) - b(k+1)*a(k);
  r(k+1) = r(k+1) - b(k+1)*r(k);
end
r(n) = r(n) / d(n);
for j=n-1:-1:1
    r(j) = r(j) - a(j)*r(j+1);
end
 
