
function [r] = trid (a, d, c, r) 
%% function [r] = trid (a, d, c, r) 
%% algorithm for solving tridag. systems
%% solves A x = r, where A = tridiag[a, d, c]
%%  note: a, d, c are all of length n - 
%%  with a(1) = c(n) = 0 
%% 
n = length(d);
for k=2:n
    piv = a(k)/d(k-1);
    d(k) = d(k) - piv*c(k-1);
    r(k) = r(k) - piv*r(k-1);
end
r(n) = r(n) / d(n);
for j=n-1:-1:1
    r(j) = (r(j) - c(j)*r(j+1))/d(j);
end
 
